using System;
using System.Windows.Forms;

using System.Resources;
using System.Runtime.InteropServices;

using WebChart;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;


namespace PerfChart
{
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;
		private System.ComponentModel.Container components = null;

		#region Windows Forms Stuff
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.button3 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.pictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pictureBox1.Location = new System.Drawing.Point(8, 8);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(776, 520);
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// button1
			// 
			this.button1.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.button1.Location = new System.Drawing.Point(64, 536);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(136, 23);
			this.button1.TabIndex = 1;
			this.button1.Text = "Basic Perf Test";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.button2.Location = new System.Drawing.Point(208, 536);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(136, 23);
			this.button2.TabIndex = 2;
			this.button2.Text = "More Complex Test";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// button3
			// 
			this.button3.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.button3.Location = new System.Drawing.Point(352, 536);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(136, 23);
			this.button3.TabIndex = 3;
			this.button3.Text = "Random Values Test";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(792, 582);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.button3,
																		  this.button2,
																		  this.button1,
																		  this.pictureBox1});
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		#endregion


		private const int maxCharts = 3;
		private const int maxPoints = 1000;

		private void button1_Click(object sender, System.EventArgs e) {
			HiPerfTimer timer = new HiPerfTimer();
			timer.Start();
			//--------------------------------------
			// Create The Chart
			ChartEngine engine = new ChartEngine();
			engine.Size = pictureBox1.Size;
			ChartCollection charts = new ChartCollection(engine);
			engine.Charts = charts;
			int chartCount=0, pointCount=0;
			for ( ; chartCount < maxCharts; chartCount++) {
				ChartPointCollection data = new ChartPointCollection();
				Chart line = new LineChart(data, Color.Red);
				line.ShowLineMarkers=false;
				for (pointCount=0 ; pointCount< maxPoints; pointCount++) {
					data.Add( new ChartPoint("Some Data", pointCount) );
				}
				charts.Add( line );
			}
			engine.GridLines = GridLines.Horizontal;
			Image image = engine.GetBitmap();
			//--------------------------------------
			// At this point we have the chart already
			// So lets do the measurement...
			timer.Stop();
			//--------------------------------------
			// show the already generated image
			pictureBox1.Image = image;
			MessageBox.Show( 
					string.Format("Timing: \n {0} msec. \n For {1} Charts With {2} points each.",
								timer.Duration, chartCount , pointCount  ));
			//--------------------------------------
			// if we want, we can save the file
			image.Save(@"C:\chart.png", ImageFormat.Png);
		}

		private void button2_Click(object sender, System.EventArgs e) {
			HiPerfTimer timer = new HiPerfTimer();
			timer.Start();
			//--------------------------------------
			// Create The "ChartSpace"
			ChartEngine engine = new ChartEngine();
			engine.Size = pictureBox1.Size;
			ChartCollection charts = new ChartCollection(engine);
			engine.Charts = charts;
			engine.TopPadding = 20;
			engine.Padding = 20;
			engine.HasChartLegend = true;
			// Set the Title
			ChartText title = new ChartText();
			engine.Title = title;
			Font font = new Font("Tahoma", 12, FontStyle.Bold);
			title.Font = font;
			title.ForeColor = Color.White;
			title.Text = "My Chart";
			// Set the Background
			ChartInterior interior = engine.Background;
			interior.Type = InteriorType.Hatch;
			interior.Color = Color.CornflowerBlue;
			interior.HatchStyle = HatchStyle.DiagonalBrick;
			interior.ForeColor = Color.Black;
			// Set the PlotBackGround
			interior = engine.PlotBackground;
			interior.Type = InteriorType.LinearGradient;
			interior.Color = Color.CornflowerBlue;
			interior.ForeColor = Color.Beige;
			interior.StartPoint = new Point(0,0);
			interior.EndPoint = new Point(engine.Size.Width ,engine.Size.Height );
			interior.Angle=90;
			// Create the Charts
			int chartCount=0, pointCount=0;
			for ( ; chartCount < maxCharts; chartCount++) {
				ChartPointCollection data = new ChartPointCollection();
				Chart line = new LineChart(data, Color.Red);
				line.ShowLineMarkers=false;
				line.Legend = "Chart: " + chartCount.ToString();
				for (pointCount=0 ; pointCount< maxPoints; pointCount++) {
					data.Add( new ChartPoint("Some Data", pointCount) );
				}
				charts.Add( line );
			}
			engine.GridLines = GridLines.Horizontal;
			Image image = engine.GetBitmap();
			//--------------------------------------
			// At this point we have the chart already
			// So lets do the measurement...
			timer.Stop();
			//--------------------------------------
			// show the already generated image
			pictureBox1.Image = image;
			MessageBox.Show( 
				string.Format("Timing: \n {0} msec. \n For {1} Charts With {2} points each.",
				timer.Duration, chartCount , pointCount  ));
			//--------------------------------------
			// if we want, we can save the file
			image.Save(@"C:\chart.png", ImageFormat.Png);
		}

		private void button3_Click(object sender, System.EventArgs e) {
			HiPerfTimer timer = new HiPerfTimer();
			timer.Start();
			//--------------------------------------
			// Create The "ChartSpace"
			ChartEngine engine = new ChartEngine();
			engine.Size = pictureBox1.Size;
			ChartCollection charts = new ChartCollection(engine);
			engine.Charts = charts;
			engine.TopPadding = 20;
			engine.Padding = 20;
			engine.ChartPadding = 20;
			engine.ShowXValues = true;
			engine.ShowYValues=true;
			engine.ShowTitlesOnBackground = true;
			// Set the Title
			ChartText title = new ChartText();
			engine.Title = title;
			Font font = new Font("Arial", 12, FontStyle.Bold);
			title.Font = font;
			title.StringFormat.Alignment = StringAlignment.Near;
			title.ForeColor = Color.Salmon;
			title.Text = "Chart Engine...";
			// Set the Background
			ChartInterior interior = engine.Background;
			interior.Type = InteriorType.LinearGradient;
			interior.Color = Color.Blue;
			interior.ForeColor = Color.Red;
			interior.StartPoint = new Point(0,0);
			interior.EndPoint = new Point(engine.Size.Width ,engine.Size.Height );
			// Set the PlotBackground
			interior = engine.PlotBackground;
			interior.Type = InteriorType.Texture;
			interior.Image  = new Bitmap(typeof(Form1).Assembly.GetManifestResourceStream("PerfChart.webnet.JPG"));
			// Create the Charts
			int chartCount=0, pointCount=0;
			Random rnd = new Random();
			for ( ; chartCount < maxCharts; chartCount++) {
				ChartPointCollection data = new ChartPointCollection();
				Chart line = new ColumnChart(data, Color.FromArgb( rnd.Next(255), rnd.Next(255) , rnd.Next(255) ));
				line.Fill.Type= InteriorType.Hatch;
				line.Fill.HatchStyle = HatchStyle.DiagonalBrick;
				line.Fill.Color = Color.Transparent;
				line.Fill.ForeColor = Color.Silver;
				line.ShowLineMarkers=false;
				line.Legend = "Chart: " + chartCount.ToString();
				for (pointCount=0 ; pointCount< 30; pointCount++) {
					int iValue = rnd.Next(100);
					data.Add( new ChartPoint(pointCount.ToString(), iValue) );
				}
				charts.Add( line );
			}
			Image image = engine.GetBitmap();
			//--------------------------------------
			// At this point we have the chart already
			// So lets do the measurement...
			timer.Stop();
			//--------------------------------------
			// show the already generated image
			pictureBox1.Image = image;
			MessageBox.Show( 
				string.Format("Timing: \n {0} msec. \n For {1} Charts With {2} points each.",
				timer.Duration, chartCount , pointCount  ));
			//--------------------------------------
			// if we want, we can save the file
			image.Save(@"C:\chart.png", ImageFormat.Png);
			interior.Image.Dispose();
		}
	}
}
